#include "Aerobics.h"
//߹ݴʦ

Aerobics::Aerobics()
{
	last_down = 0;
	last_jump = 0;

	stretch_left_status = 0;
	stretch_right_status = 0;

	lift_left_status = 0;
	lift_right_status = 0;

	left_wait_time = 0;
	right_wait_time = 0;

	special_down = 0;
	last_special_down = 0;

	stretch_front_left_status = 0;
	stretch_front_right_status = 0;

	deny_down_time = 0;
}

void Aerobics::ResetDenyDownTime(int time_stamp)
{
	deny_down_time = time_stamp;
}

bool Aerobics::isValidDown(int time_stamp)
{
	if (time_stamp - deny_down_time < 10 && time_stamp - deny_down_time >= 0)
	{
		return false;
	}

	return true;
}

void Aerobics::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{
	memset(result, -1, 4 * sizeof(int));

	setData(right_shoes_data_vector, time_stamp, right_pos[0] * 0.001f, right_pos[1] * 0.001f, right_pos[2] * 0.001f,
		right_att[0] * 0.0001f, right_att[1] * 0.0001f, right_att[2] * 0.0001f, right_zupt, rssi);

	setData(left_shoes_data_vector, time_stamp, left_pos[0] * 0.001f, left_pos[1] * 0.001f, left_pos[2] * 0.001f,
		left_att[0] * 0.0001f, left_att[1] * 0.0001f, left_att[2] * 0.0001f, left_zupt, rssi);

	calGlobalPos(right_shoes_data_vector, right_step_data_vector, right_global_pos, right_shoes_data_vector[0].heading, 10.0f / 180 * PI, RIGHT_FOOT);

	calGlobalPos(left_shoes_data_vector, left_step_data_vector, left_global_pos, left_shoes_data_vector[0].heading, -10.0f / 180 * PI, LEFT_FOOT);


	if (left_shoes_data_vector.size() == 1 && left_shoes_data_vector.back().zupt)
	{
		memset(left_global_pos, 0, 3 * sizeof(float));
	}

	if (right_shoes_data_vector.size() == 1 && right_shoes_data_vector.back().zupt)
	{
		memset(right_global_pos, 0, 3 * sizeof(float));
	}

	//static int time_count;
	//std::cout << time_count++ << std::endl;
	//õŵĿ״̬ʹڿֻжһΣڴزܴ

	//̧ôصʱ򣬽ᴥ¶ˣһֹ¶׵ʱ
	/*if ((left_step_data_vector.size() > 1 && left_step_data_vector.front().zupt == 1 && left_step_data_vector.back().zupt == 1 && lift_left_status == 0)
		||(right_step_data_vector.size() > 1 && right_step_data_vector.front().zupt == 1 && right_step_data_vector.back().zupt == 1 && lift_right_status == 0))
	{
		ResetDenyDownTime(time_stamp);
	}*/


	if (left_zupt)
	{
		stretch_left_status = 1;

		stretch_front_left_status = 1;

		lift_left_status = 1;
	}

	if (right_zupt)
	{
		stretch_right_status = 1;

		stretch_front_right_status = 1;

		lift_right_status = 1;
	}

	if (last_down == 0 && down != 0)
	{
		addMotionCount(DOWN_COUNT);

		std::cout << "normal down motion" << endl;
		result[0] = MOTION_DOWN;

		stretch_front_right_status = 0;
		lift_right_status = 0;

		stretch_front_left_status = 0;
		lift_left_status = 0;

	}

	if (left_step_data_vector.size() > 1 && left_step_data_vector.front().zupt == 1 && left_step_data_vector.back().zupt == 0)
	{
		setResult(left_step_data_vector, LEFT_FOOT);
	}



	if (right_step_data_vector.size() > 1 && right_step_data_vector.front().zupt == 1 && right_step_data_vector.back().zupt == 0)
	{
		setResult(right_step_data_vector, RIGHT_FOOT);
	}



	//ж
	//Ϸ
	left_acc_deque.push_back(sqrt(left_acc[0] * left_acc[0] + left_acc[1] * left_acc[1]));
	right_acc_deque.push_back(sqrt(right_acc[0] * right_acc[0] + right_acc[1] * right_acc[1]));

	if (left_acc_deque.size() > 10)
	{
		left_acc_deque.pop_front();
		right_acc_deque.pop_front();
	}

	int acc_valid = 0;
	if (left_acc_deque.size() == 10)
	{
		int left_max_val = *(std::max_element(left_acc_deque.begin(), left_acc_deque.end()));
		int left_min_val = *(std::min_element(left_acc_deque.begin(), left_acc_deque.end()));

		int right_max_val = *(std::max_element(right_acc_deque.begin(), right_acc_deque.end()));
		int right_min_val = *(std::min_element(right_acc_deque.begin(), right_acc_deque.end()));


		if (left_max_val - left_min_val < 512 && right_max_val - right_min_val < 512)
		{
			acc_valid = 1;
		}
	}
	//std::cout << "time_stamp : " << time_stamp << endl;
	//if (last_down == 0 && down == 1 && isValidDown(time_stamp))
	//if (last_down == 0 && down != 0 && wait_down == 0 && deny_down_time == 0)



	last_down = down;

	if (left_step_data_vector.size() > 1 && left_step_data_vector.front().zupt == 1 && left_step_data_vector.back().zupt == 1 &&
		unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left))
	{
		addMotionCount(STEP_COUNT);
	}

	if (right_step_data_vector.size() > 1 && right_step_data_vector.front().zupt == 1 && right_step_data_vector.back().zupt == 1 &&
		unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right))
	{
		addMotionCount(STEP_COUNT);
	}

	setPolarAccUnzupt(max_acc_unzupt_left, min_acc_unzupt_left, left_acc, left_zupt);
	setPolarAccUnzupt(max_acc_unzupt_right, min_acc_unzupt_right, right_acc, right_zupt);
}

void Aerobics::setResult(deque<shoes_data_cell>& step_data_vector,int LEFT_OR_RIGHT)
{
	// й켣
	//ʵʵʱ⵽켣ǷϴģΪ˷򵥣ڴص˲
	//1ȼ⵽ZĹ켣Ƿ10cm, ھͻᴥж
	//2 ͬʱͬһѭжƽ棨X,Yĵ

	float high = step_data_vector.back().pos_z;

	float plane_length = sqrt(step_data_vector.back().pos_x * step_data_vector.back().pos_x 
		+ step_data_vector.back().pos_y * step_data_vector.back().pos_y);

	float pitch = step_data_vector.back().pitch;

	float roll  = step_data_vector.back().roll;

	//ʱȽ̧ŵĸ߶ֵΪ0.1m, ŵľΪ0.2m

		//if (LEFT_OR_RIGHT == LEFT_FOOT && stretch_left_status == 1 && roll > -2.9f && roll < 0.0f)
	if (LEFT_OR_RIGHT == LEFT_FOOT && stretch_left_status == 1 && roll > 1.8f &&  pitch > -0.4f)
	{
		std::cout << "MOTION_STRETCH_LEFT : " << ""<< endl;
		result[0] = MOTION_STRETCH_LEFT;
		stretch_left_status = 0;
		lift_left_status = 0;
		stretch_front_left_status = 0;
	}
	else if(LEFT_OR_RIGHT == RIGHT_FOOT && stretch_right_status == 1 && roll > 1.8f && pitch > -0.4f)
	{
		std::cout << "MOTION_STRETCH_RIGHT: " << "Ҳ" << endl;
		result[0] = MOTION_STRETCH_RIGHT;
		stretch_right_status = 0;
		lift_right_status = 0;
		stretch_front_right_status = 0;
	}

	else if (LEFT_OR_RIGHT == LEFT_FOOT && stretch_front_left_status == 1
		&& pitch < -0.4f)
	{
		std::cout << "MOTION_STRETCH_FRONT_LEFT: " << "ǰ" << endl;
		result[0] = MOTION_STRETCH_FRONT_LEFT;
		stretch_front_left_status = 0;
		lift_left_status = 0;
	}
	else if (LEFT_OR_RIGHT == RIGHT_FOOT && stretch_front_right_status == 1 
		&& pitch < -0.4f)
	{
		std::cout << "MOTION_STRETCH_FRONT_RIGHT" << "ǰ" << endl;
		result[0] = MOTION_STRETCH_FRONT_RIGHT;
		stretch_front_right_status = 0;
		lift_right_status = 0;
	}

	else if (fabs(high) > high_thresh && plane_length < 0.2f && pitch > 0.3f)
	{
		if (LEFT_OR_RIGHT == LEFT_FOOT && lift_left_status == 1)
		{
			std::cout << "MOTION_LIFT_LEFT " << "̧" << endl;
			result[0] = MOTION_LIFT_LEFT;
			lift_left_status = 0;
		}
		else if (LEFT_OR_RIGHT == RIGHT_FOOT && lift_right_status == 1)
		{
			std::cout << "MOTION_LIFT_RIGHT " << "̧" << endl;
			result[0] = MOTION_LIFT_RIGHT;
			lift_right_status = 0;
		}
	}

//	if (plane_length > 0.2)
//	{
//		if (LEFT_OR_RIGHT == RIGHT_FOOT)
//		{
//			std::cout << "step_data_vector.back().pos_y : " << step_data_vector.back().pos_y << std::endl;
//		}
//		std::cout << "test : plane_length > 0.2" << endl;
//	}
//
//	if (high > high_thresh)
//	{
//		std::cout << "high > high_thresh" << endl;
//	}
}
