

#include "BuildHouse.h"

bool isValidAcc(deque<dualAccData>& dual_acc, int start_index,  int thresh_hold)
{
	int left_max_val = dual_acc[start_index].left_acc;
	int left_min_val = dual_acc[start_index].left_acc;

	int right_max_val = dual_acc[start_index].right_acc;
	int right_min_val = dual_acc[start_index].right_acc;

	for (int i = start_index; i < dual_acc.size(); i++)
	{
		if (dual_acc[i].left_acc > left_max_val)
		{
			left_max_val = dual_acc[i].left_acc;
		}
		if (dual_acc[i].right_acc > right_max_val)
		{
			right_max_val = dual_acc[i].right_acc;
		}

		if (dual_acc[i].left_acc < left_min_val)
		{
			left_min_val = dual_acc[i].left_acc;
		}
		if (dual_acc[i].right_acc < right_min_val)
		{
			right_min_val = dual_acc[i].right_acc;
		}
		
	}

	if (left_max_val - left_min_val < thresh_hold && right_max_val - right_min_val < thresh_hold)
	{
		return true;
	}

	return false;
}




void detect_cancave_curve_top(deque<int>& dual_press_back, int& max_index, int& right_size_index, int& left_size_index)
{
	//1ѰСֵ
	int k = dual_press_back.size() - 1;

	right_size_index = k;

	while (k > 2)
	{
		if (dual_press_back[k] < dual_press_back[k - 1] + 50
			|| dual_press_back[k] < dual_press_back[k - 2]
			|| dual_press_back[k] < dual_press_back[k - 3])
		{
			k--;
		}
		else
		{
			break;
		}


	}

	max_index = k;


	while (k > 2)
	{
		if (dual_press_back[k] > dual_press_back[k - 1] - 50
			|| dual_press_back[k] > dual_press_back[k - 2]
			|| dual_press_back[k] > dual_press_back[k - 3])
		{
			k--;
		}
		else
		{
			break;
		}
	}


	left_size_index = k;

	int distance = abs(dual_press_back[k] - dual_press_back[right_size_index]);

	while (k < max_index)
	{
		if (distance > abs(dual_press_back[k] - dual_press_back[right_size_index]))
		{
			distance = abs(dual_press_back[k] - dual_press_back[right_size_index]);

			left_size_index = k;
		}
		k++;
	}
}



int mid_window_val(deque<int>& press_deque, int mid_window_size)
{
	deque<int> press_deque_temp = press_deque;

	if (press_deque_temp.size() >= mid_window_size)
	{
		std::sort(press_deque_temp.begin(), press_deque_temp.end());
	}
	else
	{
		return press_deque.back();
	}

	//return press_deque[press_deque_temp.size() / 2];

	return press_deque_temp[0];
}

int BuildHouse::back_press_up_trend(deque<int>& left_press_deque, deque<int>& right_press_deque)
{
	if (left_press_deque.size() > 20)
	{
		int i = left_press_deque.size() - 1;

		while (i > 10 && (left_press_deque[i] >= left_press_deque[i - 1] || left_press_deque[i] >= left_press_deque[i - 2]
			|| left_press_deque[i] >= left_press_deque[i - 3]) &&
			(right_press_deque[i] >= right_press_deque[i - 1] || right_press_deque[i] >= right_press_deque[i - 2]
				|| right_press_deque[i] >= right_press_deque[i - 3])
			&& left_press_deque[i] > 12000 && right_press_deque[i] > 12000)
		{
			i--;
		}

		if (left_press_deque.back() > left_press_deque[i] + 1000&& right_press_deque.back() > right_press_deque[i] + 1000)
		{
			return 1;
		}
	}

	return 0;
}

void BuildHouse::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{
	result[0] = -1;

	if (last_down == 0 && down == 1)
	//if((front_down == 1 || back_down == 1))
	{
		result[0] = MOTION_DOWN;

		addMotionCount(DOWN_COUNT);

		std::cout << "BuidHouse : Down" << endl;
	}



	last_down = down;


}