#pragma once
#ifndef _PUBLIC_MOTION_H
#define _PUBLIC_MOTION_H

#include <iostream>

class publicMotion {

public:
	publicMotion();

	void setMagData(int left_front_data, int right_front_data, int left_mag_data, int right_mag_data);
	
	void meanFiltData(int time_count, int mag_data, int* mag_data_window, int* mean_mag_data);

	void setSpecialPoint(int left_front_data, int right_front_data, int left_mag_data, int right_mag_data);

	int getDownData(int left_front_data, int right_front_data, int left_mag_data, int right_mag_data);

	void setSpecialPoint_part(int mag_data, int* mean_data, int *max_val, int *down_point, int *up_time);

private:
	int left_front_mag_window[5];
	int right_front_mag_window[5];

	int left_back_mag_window[5];
	int right_back_mag_window[5];

	int left_front_mag_mean_window[15];
	int right_front_mag_mean_window[15];

	int left_back_mag_mean_window[15];
	int right_back_mag_mean_window[15];

	int motion_time;

	int left_back_mag_point_val;
	int right_back_mag_point_val;

	int left_front_mag_point_val;
	int right_front_mag_point_val;

	int left_back_mag_up_max;
	int right_back_mag_up_max;

	int left_front_mag_up_max;
	int right_front_mag_up_max;

	int left_front_up_time;
	int right_front_up_time;
	
	int left_back_up_time;
	int right_back_up_time;

};


#endif
