#include "FingerGuessing.h"

FingerGuessing::FingerGuessing()
{
	left_foot_has_init = 0;
	right_foot_has_init = 0;

	left_heading = 0;
	right_heading = 0;

	left_zupt_count = 0;
	right_zupt_count = 0;

	left_cmd_status = -1;
	right_cmd_status = -1;

	last_left_cmd_status = -1;
	last_right_cmd_status = -1;

	right_cmd_cur_status = -1;
	left_cmd_cur_status = -1;

	right_cmd_wait_time = 0;
	left_cmd_wait_time = 0;

	memset(left_global_pos, 0, 3 * sizeof(float));
	memset(right_global_pos, 0, 3 * sizeof(float));

	memset(left_cmd_global_pos, 0, 3 * sizeof(float));
	memset(right_cmd_global_pos, 0, 3 * sizeof(float));

	memset(result, -1, 4 * sizeof(int));

	//ԭ
	left_global_pos_vector.push_back({ 0, 0, 0, 0 });
	right_global_pos_vector.push_back({ 0, 0, 0, 0 });

}

void FingerGuessing::setData(deque<shoes_data_cell>& shoes_data_vector, int time_stamp, float pos_x, float pos_y, float pos_z, float heading, float pitch, float roll, int zupt, int rssi)
{
	if (shoes_data_vector.size() > 0)
	{
		if (shoes_data_vector.front().zupt == 0)
		{
			shoes_data_vector.clear();
		}
		else if (shoes_data_vector.back().zupt == 1 && zupt == 1)
		{
			shoes_data_vector.clear();
		}
	}
	shoes_data_vector.push_back({ time_stamp,  pos_x,  pos_y,  pos_z, heading, pitch, roll, zupt, rssi });
}

void FingerGuessing::calGlobalPos(deque<shoes_data_cell>& shoes_data_vector, deque<shoes_data_cell>& step_data_vector, float* global_pos, int LEFT_OR_RIGHT)
{
	int length = shoes_data_vector.size();

	if (length == 0)
	{
		step_data_vector.clear();

		return;
	}

	shoes_data_cell shoes_data_temp = shoes_data_vector.back();

	if (length == 1)
	{
		step_data_vector.clear();

		shoes_data_temp.pos_x = 0;
		shoes_data_temp.pos_y = 0;
		shoes_data_temp.pos_z = 0;

		step_data_vector.push_back(shoes_data_temp);

		return;
	}

	float pos_offset[3];

	pos_offset[0] = shoes_data_vector.at(length - 1).pos_x - shoes_data_vector.at(length - 2).pos_x;
	pos_offset[1] = shoes_data_vector.at(length - 1).pos_y - shoes_data_vector.at(length - 2).pos_y;
	pos_offset[2] = shoes_data_vector.at(length - 1).pos_z - shoes_data_vector.at(length - 2).pos_z;

	float posTemp[3];

	float heading = left_heading;

	if (LEFT_OR_RIGHT == RIGHT_FOOT)
	{
		heading = right_heading;
	}

	posTemp[0] = cos(heading) * pos_offset[0] + sin(heading) * pos_offset[1];
	posTemp[1] = -sin(heading) * pos_offset[0] + cos(heading) * pos_offset[1];


	if (LEFT_OR_RIGHT == LEFT_FOOT)
	{
		/*
		*  ΪЬЬӳģ²򣬻ʹƵX켣䳤
		*/
		pos_offset[0] = 0.9848 * posTemp[0] + 0.1736 * posTemp[1];
		pos_offset[1] = -0.1736 * posTemp[0] + 0.9848 * posTemp[1];

	}
	else
	{
		pos_offset[0] = 0.9848 * posTemp[0] - 0.1736 * posTemp[1];
		pos_offset[1] = 0.1736 * posTemp[0] + 0.9848 * posTemp[1];
	}

	//pos_offset[0] = posTemp[0];
	//pos_offset[1] = posTemp[1];

	for (int i = 0; i < 3; i++)
	{
		global_pos[i] = global_pos[i] + pos_offset[i];
	}

	shoes_data_temp.pos_x = step_data_vector.back().pos_x + pos_offset[0];
	shoes_data_temp.pos_y = step_data_vector.back().pos_y + pos_offset[1];
	shoes_data_temp.pos_z = step_data_vector.back().pos_z + pos_offset[2];

	step_data_vector.push_back(shoes_data_temp);
}

void FingerGuessing::ProcessResult(int zupt, int& zupt_count, int& has_init, float heading,
	float& rotate_heading, float* global_pos, deque<shoes_data_cell>& step_data_vector,
	deque<globalPos_struct>& global_pos_vector, int& cmd_status, int LEFT_OR_RIGHT)
{

	if (zupt && step_data_vector.back().rssi < 30)
	{
		zupt_count++;
	}
	else
	{
		zupt_count = 0;
	}

	//Ҫվ
	if (zupt_count > 5)
	{
		has_init = 1;

		rotate_heading = heading;

		memset(global_pos, 0, 3 * sizeof(float));

		zupt_count = 0;
	}

	if (has_init == 0)
	{
		memset(global_pos, 0, 3 * sizeof(float));
	}

	if (step_data_vector.size() > 1 && step_data_vector.front().zupt == 1 && step_data_vector.back().zupt == 1)
	{
		if (LEFT_OR_RIGHT == LEFT_FOOT)
		{
			std::cout << "Left Foot : " << endl << endl;
		}
		else
		{
			std::cout << "Right Foot : " << endl << endl;
		}

		//ѰҵСֵ
		int vector_length = global_pos_vector.size();

		float distance_point = 0.1f;

		int index = -1;


		for (int i = 0; i < vector_length; i++)
		{
			//Ѱȹĵ
			float dx = global_pos[0] - global_pos_vector.at(i).pos_x;
			float dy = global_pos[1] - global_pos_vector.at(i).pos_y;

			float distance_temp = sqrt(dx * dx + dy * dy);

			float global_pos_distance = sqrt(global_pos_vector.at(i).pos_x * global_pos_vector.at(i).pos_x + global_pos_vector.at(i).pos_y * global_pos_vector.at(i).pos_y);

			if (i == 0 && step_data_vector.back().rssi < 25)
			{
				std::cout << "test : if (distance_temp < 0.05f) " << dx << " , dy" << dy << endl;

				index = i;

				distance_point = distance_temp;

			}
			else if (i != 0  && distance_temp < distance_point)
			{
				std::cout << "test : distance_temp < distance_point  : dx " << dx << " , dy" << dy << endl;

				index = i;

				distance_point = distance_temp;

			}
		}


		if (index == -1)
		{
			std::cout << "no find similar point" << endl;
			//ûҵ׼ʱ򣬼⵽ʱ,ж
			//⵽ӽԭʱӦΪ0

			global_pos_vector.push_back({ 0, global_pos[0], global_pos[1],global_pos[2] });

			std::cout << " pos_x : " << global_pos_vector.back().pos_x
				<< " pos_y : " << global_pos_vector.back().pos_y
				<< " pos_z : " << global_pos_vector.back().pos_z << endl;

		}
		else
		{
			std::cout << "has find similar point" << endl;

			global_pos[0] = global_pos_vector.at(index).pos_x;
			global_pos[1] = global_pos_vector.at(index).pos_y;
			global_pos[2] = global_pos_vector.at(index).pos_z;
		}
		//һλ
		/*if (fabsf(global_pos[0]) < 0.05f)
		{
			global_pos[0] = 0.0f;
		}
		if (fabsf(global_pos[1]) < 0.05f)
		{
			global_pos[1] = 0.0f;
		}*/


		std::cout << "cur_pos[0] : " << global_pos[0] << " , " << "cur_pos[1] : " << global_pos[1]
			<< " , " << "cur_pos[2] : " << global_pos[2] << " , " << endl;

		if (sqrt(global_pos[0] * global_pos[0] + global_pos[1] * global_pos[1]) < 0.1f)
		{
			std::cout << "if (sqrt(global_pos[0] * global_pos[0] + global_pos[1] * global_pos[1]) < 0.1f)" << endl;

			global_pos_vector.clear();

			global_pos_vector.push_back({ 0, 0, 0, 0 });

			memset(global_pos, 0, 3 * sizeof(float));
		}


	}

	//Ϊ˷ֹ󴥵㣬ص

}

void setPolarAccUnzupt(int* max_acc, int* min_acc, int* acc, int zupt)
{
	if (zupt != 1)
	{
		for (int i = 0; i < 3; i++)
		{
			if (max_acc[i] < acc[i])
			{
				max_acc[i] = acc[i];
			}

			if (min_acc[i] > acc[i])
			{
				min_acc[i] = acc[i];
			}
		}
	}
	else
	{
		for (int i = 0; i < 3; i++)
		{
			max_acc[i] = acc[i];
			min_acc[i] = acc[i];
		}
	}

}

bool unzuptValid(int* max_acc, int* min_acc)
{
	//if (max_acc[0] - min_acc[0] > 1024 || max_acc[1] - min_acc[1] > 1024 || max_acc[2] - min_acc[2] > 1024)
	if (max_acc[0] > 2048 || min_acc[0] < -2048
		|| max_acc[1] > 2048 || min_acc[1] < -2048 || max_acc[2] > 4096 || min_acc[2] < 0)
	{
		return true;
	}

	return false;
}

void FingerGuessing::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{

	setData(right_shoes_data_vector, time_stamp, right_pos[0] * 0.001f, right_pos[1] * 0.001f, right_pos[2] * 0.001f,
		right_att[0] * 0.0001f, right_att[1] * 0.0001f, right_att[2] * 0.0001f, right_zupt, rssi);

	setData(left_shoes_data_vector, time_stamp, left_pos[0] * 0.001f, left_pos[1] * 0.001f, left_pos[2] * 0.001f,
		left_att[0] * 0.0001f, left_att[1] * 0.0001f, left_att[2] * 0.0001f, left_zupt, rssi);

	calGlobalPos(right_shoes_data_vector, right_step_data_vector, right_global_pos, RIGHT_FOOT);

	calGlobalPos(left_shoes_data_vector, left_step_data_vector, left_global_pos, LEFT_FOOT);


	ProcessResult(right_zupt, right_zupt_count, right_foot_has_init, right_att[0] * 0.0001f,
		right_heading, right_global_pos, right_step_data_vector,
		right_global_pos_vector, right_cmd_status, RIGHT_FOOT);

	ProcessResult(left_zupt, left_zupt_count, left_foot_has_init, left_att[0] * 0.0001f,
		left_heading, left_global_pos, left_step_data_vector,
		left_global_pos_vector, left_cmd_status, LEFT_FOOT);

	memcpy(rssi_buff, rssi_buff + 1, 4 * sizeof(int));

	//std::cout << " figureGuessing rssi : " << rssi << endl;

	//ͨRSSIжϻع鵽ԭ
	if ((last_right_zupt == 0 && right_zupt == 1 && unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left) && rssi < rssi_threshold)
		|| (last_left_zupt == 0 && left_zupt == 1 && unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right) && rssi < rssi_threshold)
		|| (left_zupt == 1 && right_zupt == 1 && rssi < 23))
	{
		memset(left_global_pos, 0, 3 * sizeof(float));
		memset(right_global_pos, 0, 3 * sizeof(float));

		right_global_pos_vector.clear();
		left_global_pos_vector.clear();

		left_global_pos_vector.push_back({ 0,0,0,0 });
		right_global_pos_vector.push_back({ 0,0,0,0 });
	}

	//ͨٶȡԼvectorѾ˿еλжʱ
	if (left_step_data_vector.size() > 1 && left_step_data_vector.front().zupt == 1 && left_step_data_vector.back().zupt == 1
		&& unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left))
	{
		left_cmd_wait_time = time_stamp;
	}

	if (right_step_data_vector.size() > 1 && right_step_data_vector.front().zupt == 1 && right_step_data_vector.back().zupt == 1
		&& unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right))
	{

		right_cmd_wait_time = time_stamp;
	}

	setPolarAccUnzupt(max_acc_unzupt_left, min_acc_unzupt_left, left_acc, left_zupt);
	setPolarAccUnzupt(max_acc_unzupt_right, min_acc_unzupt_right, right_acc, right_zupt);

	memset(result, -1, 4 * sizeof(int));

	if (time_stamp - left_cmd_wait_time < 20 && time_stamp - right_cmd_wait_time < 20)
	{
		////жȭͷ
		//if (left_step_data_vector.front().rssi < rssi_threshold + 11
		//	&& right_step_data_vector.front().rssi < rssi_threshold + 11
		//	&& sqrt(right_cmd_global_pos[0] * right_cmd_global_pos[0] + right_cmd_global_pos[1] * right_cmd_global_pos[1]) < 0.15f
		//	&& sqrt(left_cmd_global_pos[0] * left_cmd_global_pos[0] + left_cmd_global_pos[1] * left_cmd_global_pos[1]) < 0.15f)

		memcpy(left_cmd_global_pos, left_global_pos, 3 * sizeof(float));
		memcpy(right_cmd_global_pos, right_global_pos, 3 * sizeof(float));

		if (sqrt(right_cmd_global_pos[0] * right_cmd_global_pos[0] + right_cmd_global_pos[1] * right_cmd_global_pos[1]) < 0.1f
				&& sqrt(left_cmd_global_pos[0] * left_cmd_global_pos[0] + left_cmd_global_pos[1] * left_cmd_global_pos[1]) < 0.1f)
		{
			addMotionCount(ROCK_COUNT);

			result[0] = MOTION_ROCK;

			std::cout << "FingureResult : MOTION_ROCK" << endl;
		}
		else
		{
			float dx = left_cmd_global_pos[0] - right_cmd_global_pos[0];

			float dy = left_cmd_global_pos[1] - right_cmd_global_pos[1];

			std::cout << "dx : " << dx << " dy : " << dy << endl;

			if ((dx > 0.12f || dx < -0.12f) && fabsf(dy) < 3.0 / 4 * fabsf(dx))
			{
				//ͳƲ
				addMotionCount(PAPER_COUNT);

				result[0] = MOTION_PAPER;

				std::cout << "MOTION_PAPER, RSSI : " << rssi << endl;

				std::cout << "FingureResult : MOTION_PAPER" << endl;
			
			}
			else if ((dy > 0.12f || dy < -0.12f) && fabsf(dx) < 3.0 / 4 * fabsf(dy))
			{
				//ͳƲ
				addMotionCount(SCISSORS_COUNT);

				result[0] = MOTION_SCISSORS;

				std::cout << "FingureResult : MOTION_SCISSORS" << endl;

				
			}
			/*else if (dy > 0.3f || dy < -0.3f || dx > 0.3f || dx < -0.3f)*/
			else if (sqrt(dx * dx + dy * dy) > 0.25f)
			{
				if (fabsf(dy) > fabsf(dx))
				{
					addMotionCount(SCISSORS_COUNT);

					result[0] = MOTION_SCISSORS;

					std::cout << "dy > dx FingureResult : MOTION_SCISSORS" << endl;
				}
				else
				{
					addMotionCount(PAPER_COUNT);

					result[0] = MOTION_PAPER;

					std::cout << "dy < dx FingureResult : MOTION_PAPER" << endl;
				}
			}


		}

		left_cmd_wait_time = 0;
		right_cmd_wait_time = 0;
	}

	/*if (left_cmd_wait_time > 0)
	{
		left_cmd_wait_time--;
	}

	if (right_cmd_wait_time > 0)
	{
		right_cmd_wait_time--;
	}*/

	last_right_zupt = right_zupt;
	last_left_zupt = left_zupt;

}



void FingerGuessing::getResult(int* dec)
{
	memcpy(dec, result, 4 * sizeof(int));
}

float FingerGuessing::getGamePos(int left_or_right, int index)
{
	if (index < 0 || index > 2)
		return -1;

	if (left_or_right == LEFT_FOOT)
	{
		return left_global_pos[index];
	}
	else
	{
		return right_global_pos[index];
	}
}