

#include "BuildHouse.h"

bool isValidAcc(deque<dualAccData>& dual_acc, int start_index,  int thresh_hold)
{
	int left_max_val = dual_acc[start_index].left_acc;
	int left_min_val = dual_acc[start_index].left_acc;

	int right_max_val = dual_acc[start_index].right_acc;
	int right_min_val = dual_acc[start_index].right_acc;

	for (int i = start_index; i < dual_acc.size(); i++)
	{
		if (dual_acc[i].left_acc > left_max_val)
		{
			left_max_val = dual_acc[i].left_acc;
		}
		if (dual_acc[i].right_acc > right_max_val)
		{
			right_max_val = dual_acc[i].right_acc;
		}

		if (dual_acc[i].left_acc < left_min_val)
		{
			left_min_val = dual_acc[i].left_acc;
		}
		if (dual_acc[i].right_acc < right_min_val)
		{
			right_min_val = dual_acc[i].right_acc;
		}
		
	}

	if (left_max_val - left_min_val < thresh_hold && right_max_val - right_min_val < thresh_hold)
	{
		return true;
	}

	return false;
}




void detect_cancave_curve_top(deque<int>& dual_press_back, int& max_index, int& right_size_index, int& left_size_index)
{
	//1ѰСֵ
	int k = dual_press_back.size() - 1;

	right_size_index = k;

	while (k > 2)
	{
		if (dual_press_back[k] < dual_press_back[k - 1] + 50
			|| dual_press_back[k] < dual_press_back[k - 2]
			|| dual_press_back[k] < dual_press_back[k - 3])
		{
			k--;
		}
		else
		{
			break;
		}


	}

	max_index = k;


	while (k > 2)
	{
		if (dual_press_back[k] > dual_press_back[k - 1] - 50
			|| dual_press_back[k] > dual_press_back[k - 2]
			|| dual_press_back[k] > dual_press_back[k - 3])
		{
			k--;
		}
		else
		{
			break;
		}
	}


	left_size_index = k;

	int distance = abs(dual_press_back[k] - dual_press_back[right_size_index]);

	while (k < max_index)
	{
		if (distance > abs(dual_press_back[k] - dual_press_back[right_size_index]))
		{
			distance = abs(dual_press_back[k] - dual_press_back[right_size_index]);

			left_size_index = k;
		}
		k++;
	}
}



int mid_window_val(deque<int>& press_deque, int mid_window_size)
{
	deque<int> press_deque_temp = press_deque;

	if (press_deque_temp.size() >= mid_window_size)
	{
		std::sort(press_deque_temp.begin(), press_deque_temp.end());
	}
	else
	{
		return press_deque.back();
	}

	//return press_deque[press_deque_temp.size() / 2];

	return press_deque_temp[0];
}

int BuildHouse::back_press_up_trend(deque<int>& left_press_deque, deque<int>& right_press_deque)
{
	if (left_press_deque.size() > 20)
	{
		int i = left_press_deque.size() - 1;

		while (i > 10 && (left_press_deque[i] >= left_press_deque[i - 1] || left_press_deque[i] >= left_press_deque[i - 2]
			|| left_press_deque[i] >= left_press_deque[i - 3]) &&
			(right_press_deque[i] >= right_press_deque[i - 1] || right_press_deque[i] >= right_press_deque[i - 2]
				|| right_press_deque[i] >= right_press_deque[i - 3])
			&& left_press_deque[i] > 12000 && right_press_deque[i] > 12000)
		{
			i--;
		}

		if (left_press_deque.back() > left_press_deque[i] + 1000&& right_press_deque.back() > right_press_deque[i] + 1000)
		{
			return 1;
		}
	}

	return 0;
}

void BuildHouse::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{

	int sdk_down = 0;
	int front_down = 0;

	result[0] = 0;

	//ٶȴ
	dual_acc.push_back({ left_acc[2], right_acc[2] });

	//ڲ
	left_press_filter_window.push_back(left_back_press);
	right_press_filter_window.push_back(right_back_press);

	//Сֵ˲ ϺõĹë
	if (left_press_filter_window.size() > 5)
	{
		left_press_filter_window.pop_front();
		right_press_filter_window.pop_front();

		left_back_press = mid_window_val(left_press_filter_window, 5);
		right_back_press = mid_window_val(right_press_filter_window, 5);

	}




	left_front_press_queue.push_back(left_front_press); left_back_press_queue.push_back(left_back_press);
	right_front_press_queue.push_back(right_front_press); right_back_press_queue.push_back(right_back_press);

	if (left_back_press_queue.size() > 40)
	{
		left_back_press_queue.pop_front(); right_back_press_queue.pop_front();
	}

	if (left_front_press_queue.size() > 40)
	{
		left_front_press_queue.pop_front(); right_front_press_queue.pop_front();
	}

	if (dual_acc.size() > 10)
	{
		dual_acc.pop_front();
	}


	if (left_front_press_queue.size() == 40)
	{
		/*
		*  ⵽ǰѹ˫Ŷ͹ߣôжΪǰ¶
		*  Ҫ˫͹ߵĶ㣬һ˫͹ߵЧʱڣ򶥵ֵҪһ˫͹ߣжЧ˫͹
		*/

		int left_max_index, left_foot_right_side_index, left_foot_left_side_index;

		detect_cancave_curve_top(left_front_press_queue, left_max_index, left_foot_right_side_index, left_foot_left_side_index);

		int right_max_index, right_foot_right_side_index, right_foot_left_side_index;
		
		detect_cancave_curve_top(right_front_press_queue, right_max_index, right_foot_right_side_index, right_foot_left_side_index);

		int left_dist = 1000, right_dist = 1000;

		if (wait_press_top_unvalid > 0)
		{
			left_dist = max(left_dist, left_front_press_top);
			right_dist = max(right_dist, right_front_press_top);
		}

		bool acc_valid = isValidAcc(dual_acc, 0, 512);
		//⵽ǰѹ˫Ŷ͹ߣôжΪǰ¶
		if (abs(left_max_index - right_max_index) < 6 &&
			right_front_press_queue[right_foot_right_side_index] - right_front_press_queue[right_max_index] < -right_dist
			&& right_front_press_queue[right_foot_left_side_index] - right_front_press_queue[right_max_index] < -right_dist
			&& left_front_press_queue[left_foot_right_side_index] - left_front_press_queue[left_max_index] < -left_dist
			&& left_front_press_queue[left_foot_left_side_index] - left_front_press_queue[left_max_index] < -left_dist
			&& right_foot_right_side_index - right_foot_left_side_index < 31
			&& left_foot_right_side_index - left_foot_left_side_index < 31
			&& acc_valid
			//&& abs(dual_press_front[right_max_index].right_press - dual_press_front[left_max_index].left_press) < 8000//ֵ
			)
		{
			// Ҫ˫͹ߵĶ㣬һ˫͹ߵЧʱڣ򶥵ֵҵĲֵҪһ˫͹ߣжЧ˫͹
			// ¼һ˫͹ߵĲֵ
			if (right_front_press_queue[right_foot_right_side_index] - right_front_press_queue[right_max_index] < -1000
				&& right_front_press_queue[right_foot_left_side_index] - right_front_press_queue[right_max_index] < -1000
				&& left_front_press_queue[left_foot_right_side_index] - left_front_press_queue[left_max_index] < -1000
				&& left_front_press_queue[left_foot_left_side_index] - left_front_press_queue[left_max_index] < -1000)
			{
				int right_dist = right_front_press_queue[right_max_index] - right_front_press_queue[right_foot_right_side_index];

				right_dist = min(right_dist, right_front_press_queue[right_max_index] - right_front_press_queue[right_foot_left_side_index]);

				//right_front_press_top = dual_press_front[right_max_index].right_press - 0.5 * right_dist;
				right_front_press_top = 0.5 * right_dist;

				int left_dist = left_front_press_queue[left_max_index] - left_front_press_queue[left_foot_right_side_index];

				left_dist = min(left_dist, left_front_press_queue[left_max_index] - left_front_press_queue[left_foot_left_side_index]);

				//left_front_press_top = dual_press_front[left_max_index].left_press - 0.5 * left_dist;
				left_front_press_top =  0.5 * left_dist;

				wait_press_top_unvalid = 60;

			}

			front_down = 1;
		}

		if ( left_front_press_queue[left_foot_right_side_index] - left_front_press_queue[left_max_index] < -2000
			&& right_front_press_queue[right_foot_right_side_index] - right_front_press_queue[right_max_index] < -2000
			&& left_foot_right_side_index - left_max_index < 30 && right_foot_right_side_index - right_max_index < 30
			)
		{

			int right_dist = right_front_press_queue[right_max_index] - right_front_press_queue[right_foot_right_side_index];

			right_dist = min(right_dist, right_front_press_queue[right_max_index] - right_front_press_queue[right_foot_left_side_index]);

			//right_front_press_top = dual_press_front[right_max_index].right_press - 0.5 * right_dist;
			right_front_press_top = 0.5 * right_dist;

			int left_dist = left_front_press_queue[left_max_index] - left_front_press_queue[left_foot_right_side_index];

			left_dist = min(left_dist, left_front_press_queue[left_max_index] - left_front_press_queue[left_foot_left_side_index]);

			//left_front_press_top = dual_press_front[left_max_index].left_press - 0.5 * left_dist;
			left_front_press_top = 0.5 * left_dist;

			wait_press_top_unvalid = 60;

			front_down = 1;
		}

	}

	int back_down = 0;
	if (left_back_press_queue.size()>=20 )
	{
		 back_down = back_press_up_trend(left_back_press_queue, right_back_press_queue);

		if (back_down)
		{
			//¼ֵ
			if (wait_back_press_top_unvalid == 0)
			{
				wait_back_press_top_unvalid = 60;

				left_back_press_top = left_back_press_queue.back();
				right_back_press_top = right_back_press_queue.back();

			}
			else
			{
				if (left_back_press_top > left_back_press_queue.back() || right_back_press_top > right_back_press_queue.back())
				{
					back_down = 0;
				}
				else
				{
					wait_back_press_top_unvalid = 60;

					left_back_press_top = left_back_press_queue.back();
					right_back_press_top = right_back_press_queue.back();
				}
			}
		}

		//int left_max_index, left_foot_right_side_index, left_foot_left_side_index;

		//detect_cancave_curve_top(left_back_press_queue, left_max_index, left_foot_right_side_index, left_foot_left_side_index);

		//int right_max_index, right_foot_right_side_index, right_foot_left_side_index;

		//detect_cancave_curve_top(right_back_press_queue, right_max_index, right_foot_right_side_index, right_foot_left_side_index);


		//int special_down = 0;

		////ͬļ˫ߣӦΪߣҸ
		//if (
		//	abs(left_max_index - right_max_index) < 11 &&
		//	right_back_press_queue[right_foot_right_side_index] - right_back_press_queue[right_max_index] < -1500
		//	&& right_back_press_queue[right_foot_left_side_index] - right_back_press_queue[right_max_index] < -1500
		//	&& left_back_press_queue[left_foot_right_side_index] - left_back_press_queue[left_max_index] < -1500
		//	&& left_back_press_queue[left_foot_left_side_index] - left_back_press_queue[left_max_index] < -1500
		//	&& right_back_press_queue[right_max_index] > 12000 && left_back_press_queue[left_max_index] > 12000
		//	)
		//{
		//	back_down = 1;
		//}

	}
	if (wait_back_press_top_unvalid > 0)
	{
		wait_back_press_top_unvalid--;
	}




	if (wait_press_top_unvalid > 0)
	{
		back_down = 0;
	}

	if (wait_press_top_unvalid > 0)
	{
		wait_press_top_unvalid--;
	}

	if ((front_down == 1 || back_down == 1) && (last_down == 0 && last_front_down == 0) && cmd_wait_time == 0)
	//if((front_down == 1 || back_down == 1))
	{
		result[0] = MOTION_DOWN;

		addMotionCount(DOWN_COUNT);

		cmd_wait_time = 20;
	}

	//ڶ׵ĵʱʱͲҪ
	if (!(front_down == 1 || back_down == 1) && cmd_wait_time > 0)
	{
		cmd_wait_time--;

	}

	last_down = back_down;

	last_front_down = front_down;


	//result[1] = left_back_press;
	//result[2] = right_back_press;
	
}